<?php

interface PaymentGateway
{
    public function doPayment();
}

class  PaypalGateway implements PaymentGateway
{
    public function __construct(
        protected string $secretKey
    )
    { }
    
    public function doPayment()
    {
        
    }
}

class  StripeGateway implements PaymentGateway
{
    public function __construct(
        protected string $secretKey
    )
    { }
    
    public function doPayment()
    {
        
    }
}

class PaymentController
{
   public function __construct(
        protected PaymentGateway $paymentGateway
   )
   { }
          
   public function __invoke(Request $request)
   {
       // ...
   }
}


$this->app()->bind(
 PaymentServiceContract::class, 
 function() {
     if (request()->gateway() === 'stripe') {
          return new StripeGateway('123');
     } 
   
    return new PaypalGateway('123');
});
